#include "inc/libmaestro.h"

// read from channel given a file descriptor
int maestroRead(int fd, unsigned char channel) {
    unsigned char command[] = {0x90, channel};

    if(write(fd, command, sizeof(command)) == -1)
    {
        perror("error writing");
        return -1;
    }
   
    unsigned char response[2];

    if(read(fd,response,2) != 2)
    {
        perror("Error reading from maestro");
        return -1;
    }

    return response[0] + 256*response[1];
}

// write target to a channel given a file descriptor
// the units of 'target' are quarter-microseconds
int maestroWrite(int fd, unsigned char channel, unsigned short target) {
    unsigned char command[] = {0x84, channel, (target & 0x7F), (target >> 7 & 0x7F)};

    if (write(fd, command, sizeof(command)) == -1)
    {
        perror("Error writing to maestro");
        return -1;
    }

    return 0;
}
