/*--------------------------------------------------------------------------+
$Id: GPIOPinNumberValueProvider.java 15846 2016-02-02 09:14:08Z zverlov $
|                                                                          |
| Copyright 2015 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.annotation;

import org.fortiss.af3.platform.model.Transceiver;
import org.fortiss.af3.platform.raspberry.model.annotation.AnnotationPackage;
import org.fortiss.af3.platform.raspberry.model.annotation.Channel;
import org.fortiss.tooling.base.annotation.valueprovider.EStructuralFeatureValueProviderBase;
import org.fortiss.tooling.base.annotation.valueprovider.IAnnotationValueProvider;

/**
 * {@link IAnnotationValueProvider} that allows to annotate a Pin Number of a GPIO
 * {@link Transceiver} used in PikeOS Platform.
 * 
 * @author chaudhary
 * @author $Author: zverlov $
 * @version $Rev: 15846 $
 * @ConQAT.Rating GREEN Hash: C69EECC82FF9912335C19FC6A5CD6996
 */

public class PWMChannelNumberValueProvider extends EStructuralFeatureValueProviderBase<Channel> {

	/** Constructor. */
	public PWMChannelNumberValueProvider() {
		super(AnnotationPackage.Literals.CHANNEL, AnnotationPackage.Literals.CHANNEL__CHANNEL);
	}

	/** {@inheritDoc} */
	@Override
	public String getAnnotationName(Channel specification) {
		return "PWM Channel";
	}
}
